package fr.inria.dioptase.examples;

import java.io.IOException;
import java.util.Vector;

import fr.inria.dioptase.Dioptase;
import fr.inria.dioptase.network.web.Http;
import fr.inria.dioptase.network.web.ServiceInvoker;
import fr.inria.dioptase.parser.JSONGenericParser;
import fr.inria.dioptase.parser.JSONStreamParser;
import fr.inria.dioptase.service.ProcessorServices;
import fr.inria.dioptase.stream.StreamSchema;
import fr.inria.dioptase.stream.StreamUrl;

/**
 * @author Benjamin Billet
 *
 */
public class Utils
{
	public static void deployCompiledTask(Dioptase dioptase, String id, String operator, Vector params, StreamUrl... urls) 
	throws IOException
	{
		ServiceInvoker invoker = new ServiceInvoker(dioptase.getContext(), "127.0.0.1", dioptase.getPort(), ProcessorServices.DeployProcessorService);
		invoker.setServiceParameter("id", id);
		invoker.setServiceParameter("operator", operator);
		
		Vector inputStreams = new Vector();
		for(int i = 0; i < urls.length; i++)
			inputStreams.add(urls[i]);
		
		if(params != null)
			invoker.setServiceParameter("params", new JSONGenericParser().serializeCollection(params));
		
		invoker.setServiceParameter("inputs", new JSONStreamParser().serializeUrls(inputStreams));
		invoker.setMime(Http.MultipartFormdataMime);
		invoker.invoke();
	}
	
	public static void deployInterpretedTask(Dioptase dioptase, String id, String logic, StreamSchema schema, StreamUrl... urls)
	throws IOException
	{
		ServiceInvoker invoker = new ServiceInvoker(dioptase.getContext(), "127.0.0.1", dioptase.getPort(), ProcessorServices.DeployProcessorService);
		invoker.setServiceParameter("id", id);
		invoker.setServiceParameter("logic", logic);
		invoker.setServiceParameter("schema", new JSONStreamParser().serializeSchema(schema));
		
		Vector inputStreams = new Vector();
		for(int i = 0; i < urls.length; i++)
			inputStreams.add(urls[i]);
		
		invoker.setServiceParameter("inputs", new JSONStreamParser().serializeUrls(inputStreams));
		
		invoker.setMime(Http.MultipartFormdataMime);
		invoker.invoke();
	}
}
